diff --git a/src/third_party/snappy/SConscript b/src/third_party/snappy/SConscript
index 0eb7487..364fa15 100644
--- a/src/third_party/snappy/SConscript
+++ b/src/third_party/snappy/SConscript
@@ -1,9 +1,13 @@
 # -*- mode: python -*-
 
 Import("env windows")
+Import("bigendian")
 
 if not windows:
     env = env.Clone()
     env.Append(CCFLAGS=['-Wno-sign-compare', '-Wno-unused-function'])
 
+if bigendian:
+    env.Append(CPPDEFINES=[ 'WORDS_BIGENDIAN' ])
+
 env.StaticLibrary('snappy', ['snappy.cc', 'snappy-sinksource.cc'])
diff --git a/src/third_party/snappy/snappy-stubs-internal.h b/src/third_party/snappy/snappy-stubs-internal.h
index 355a06b..0c2eb1c 100755
--- a/src/third_party/snappy/snappy-stubs-internal.h
+++ b/src/third_party/snappy/snappy-stubs-internal.h
@@ -179,8 +179,8 @@ class LogMessageVoidify {
 
 // Potentially unaligned loads and stores.
 
-#if 1
-//#if defined(__i386__) || defined(__x86_64__) || defined(__powerpc__) || defined(_WIN32)
+//#if 1
+#if defined(__i386__) || defined(__x86_64__) || defined(__powerpc__) || defined(_WIN32)
 
 #define UNALIGNED_LOAD16(_p) (*reinterpret_cast<const uint16 *>(_p))
 #define UNALIGNED_LOAD32(_p) (*reinterpret_cast<const uint32 *>(_p))
@@ -243,8 +243,24 @@ inline void UNALIGNED_STORE64(void *p, uint64 v) {
 #define bswap_32(x) OSSwapInt32(x)
 #define bswap_64(x) OSSwapInt64(x)
 
-#else
+#elif defined(__linux__)
 #include <byteswap.h>
+#else
+inline uint16 bswap_16(uint16 x) {
+  return (x << 8) | (x >> 8);
+}
+
+inline uint32 bswap_32(uint32 x) {
+  x = ((x & 0xff00ff00UL) >> 8) | ((x & 0x00ff00ffUL) << 8);
+  return (x >> 16) | (x << 16);
+}
+
+inline uint64 bswap_64(uint64 x) {
+  x = ((x & 0xff00ff00ff00ff00ULL) >> 8) | ((x & 0x00ff00ff00ff00ffULL) << 8);
+  x = ((x & 0xffff0000ffff0000ULL) >> 16) | ((x & 0x0000ffff0000ffffULL) << 16);
+  return (x >> 32) | (x << 32);
+}
+
 #endif
 
 #endif  // WORDS_BIGENDIAN
